/**
	@file bucket_rain_gauge_driver.h
	@author Saulo Daniel Ferreira Pontes
	@version 1.1 07/2015

	Bucket Rain Gauge 
        - Chave Ótica interrupta C860TP CTK 22113/2214
*/

#ifndef BUCKET_RAIN_GAUGUE_DRIVER_H_
#define BUCKET_RAIN_GAUGUE_DRIVER_H_

#include "device.h"
#include "config.h"

void init_pluviometer();

void pluviometer_Update();

class Bucket_Rain_Gauge_Sensor : public Sensor
{
private:

       int PIN_0;
       float data[0]; //[0]: precipitação (mm);
       float precipitation = 0; //Inicializa a precipitação

	     int FUNNEL_AREA = 16500;    //Área da boca do funil em mm quadrados
	     int ROCKER_VOLUME = 10700;   //Volume que faz as básculas virarem uma vez em mm cúbicos

	//float precipitation = 0;    //Inicializa a precipitação
	bool state_control = false; //Variável auxiliar para controle do estado da entrada

public:
	Bucket_Rain_Gauge_Sensor();
	bool sense (float[]);
        void pin(int);
        void reset();
        void update();
};

#endif /* BUCKET_RAIN_GAUGUE_DRIVER_H_ */
